Uses oldLinuX;

const cmd = '/usr/local/bin/sensors';
      tempfile = '/tmp/tempst.tmp';
      statfile = '/home/vesko/develop/vgpanel/tempst.log';
      digits = ['0'..'9'];

type Long3 = array [1..3] of Longint;

var Tm : Longint;
    T  : Text;
    s  : Long3;

Function FileExists(FN : String) : Boolean;
 var g : Stat;
 begin
 Fstat(fn, g);
 FileExists := (LinuxError <> SYS_ENoEnt);
 end;
 
Function read_int(s : string ) : longint;
 var i : Longint;
 begin
 i := 0;
 repeat
    inc(i);
    until (i >= length(s)) or ((s[i] in digits) and (s[i+1] in digits));
 if (i >= length(s)) then read_int := -1 
 else
 read_int := 10 * (ord(s[i])-48) + ord(s[i+1])-48;
 end;
 
Function GetTemps(cmd : string) : Long3;
 var t : text;
     s : string;
     L : Long3;
 begin
 shell(cmd + ' > ' + tempfile);
 l[1] := -1; l[2] := -1; l[3] := -1;
 if not fileexists(tempfile) then
    begin
	GetTemps := l;
	exit;
    end;
 assign(t, tempfile);
 reset(t);
    while not seekeof(t) do
	begin
	readln(t, s);
	if (copy (s, 1, 3) = 'M/B') then
	    l[2] := read_int(s);
	if (copy (s, 1, 3) = 'CPU') then
	    l[1] := read_int(s);
	if (copy (s, 1, 5) = 'temp3') then
	    l[3] := read_int(s);
	end;
 close(t);
 GetTemps := l;
 end; 


BEGIN
s := GetTemps(cmd);
Tm := GetEpochTime;
if not FileExists(StatFile) then
    begin
	assign(t, statfile);
	rewrite(t);
    end else
    begin
	assign(t, statfile);
	append(t);
    end;
writeln(t, tm, ' ', s[1], ' ', s[2], ' ', s[3]);
close(t);
END.
